/*
  Designed by LinJiangHua(xempo) 2003-2005
  Copyright 2004-2005 Linjianghua(xempo).
  All Rights Reserve.

  This computer program is freely. but not belong to GNU yet,
  you can redistribute it and/or modify it as published by the
  Free Software Function. if it do hard to you PC(include software),
  that is you ON RISK, xempo don't promise any thing about this 
  computer program, include it Change & Develop in the future(
  means you only get what you have got current & use it freely ).

			--- 2005 Linjianghua
*/

#include "xbin.def"

/*
if use ext-name for 2 part story dir-name, would fast to filte dir
such as :
  ...
  char dirname[15];
  ...
  char dir_ext_nam[5]; 
DOS or Linux(console) to me is same effect for my image.
*/

XBinDir *ReadDir(XBIN *pblk,long adr)
{
if(adr<1)return NULL;
if(pblk->cDir->pOwn!=adr){
XBinDir *Dir=(XBinDir *)malloc(sizeof(XBinDir));
 fseek(pblk->fpt,adr,0);
 fread(Dir,Dirsze,1,pblk->fpt);
 return Dir;
 }
else return pblk->cDir;
}

void DirStatInit(XBinDir *Dir)
{
Dir->mdf=0;	Dir->flg++;
if(Dir->flg==0)Dir->flg=2;
}

void NameCopy(char *dirnam,char *pt)
{
memcpy(dirnam,pt,DirNamLen);
dirnam[DirNamLen]=0;
/* because clean code, disk must record '\0' */
}

void *GetRoot(XBIN *pblk,XBinDir *Dir,int strmsg)
{
char *pth=NULL, *pchs, *pchs2;
static char df[]="\\";
XBinDir *Dir1;
if(Dir->parTadr<=0)return (strmsg? (void *)catstr(df,Dir->name):Dir);

Dir1=(XBinDir *)malloc(sizeof(XBinDir));
Dir1->parTadr=Dir->parTadr;
do{
  Dir1=ReadDir(pblk,Dir1->parTadr);
  if(strmsg){
	if(pth==NULL){
		pchs=catstr(df,Dir1->name);
		pchs2=catstr(df,Dir->name);
		pth=catstr(pchs,pchs2);
		}
	else {
		pchs=catstr(df,Dir1->name);
		pchs2=pth; pth=catstr(pchs,pth);
		}
	free(pchs);free(pchs2);
	}
}while(Dir1->parTadr>0);
if(strmsg){ free(Dir1);return pth; }
return Dir1;
}

void DirClose(XBIN *pblk,XBinDir *Dir)
{
if(Dir && Dir->mdf ){
	if( (Dir->mdf&8)==0&&Dir->flg>2 )Dir->flg--;
	fseek(pblk->fpt,Dir->pOwn,0);
	fwrite(Dir,Dirsze,1,pblk->fpt);
	free(Dir);
	}
}

XBinDir *BrowsDir(XBIN *pblk,char *dirnam,long pDir)
{/*this pDir is unsure dirnam's pOwn,
it's Dir link first adr of this class */
XBinDir *Dir=NULL;
while(pDir){
  Dir=ReadDir(pblk,pDir);
  if(Dir==NULL)break;
  else {
	pDir=Dir->nx;
	if(Dir->usemsg==1){
	  if(stricmp(Dir->name,dirnam)){
		if(Dir!=pblk->cDir)free(Dir);
		}
	  else return Dir;
		}
	}
   }
return NULL;
}

XBinDir *SeekDir(XBIN *pblk,char *sendnam,int *Msg)
{/*
padr:  0 is get exist,
	1 get path(Parent, often use for create one Dir)
 return is flag.
*/
XBinDir *Dir, *cDir;
int Info=1, errnmb=9, flg=*Msg;
long adr=-1, n=-1;
char *pName,*pt,*dirnam;
if(sendnam==NULL)return NULL;
if(pblk==NULL){ popMsg(BinDat[2],NULL,MB_ICONERROR|STYLE);return NULL;}

cDir=pblk->cDir;
/*------------------ get special path ------------------*/
if(memcmp(sendnam,"..\\",3)==0){
	cDir=ReadDir(pblk,cDir->parTadr);
	if(cDir==NULL)goto err;
	sendnam+=3;
	}
else if(memcmp(sendnam,"...\\",4)==0){
	n=cDir->subTadr;
	cDir->subTadr=cDir->parTadr;
	sendnam+=4;
	}
else /*if(flg==0)*/{
  if(sendnam[1]==0)switch(*sendnam){
	case '*'  : return (XBinDir *)GetRoot(pblk,cDir,0);
	case '.' : return cDir;
	case '\\' : adr=pblk->HDadr;
	}
  else if(*sendnam=='.')switch(sendnam[1]){
		case '\\' : sendnam+=2; break;/* self-own */
		case '.' : if(sendnam[2]==0){ /*Dir=NULL;*/
				adr=cDir->parTadr;
				if(adr!=0)break;
				}
		default : goto err;
	}

if(adr>0)return ReadDir(pblk,adr);
} /* ------------------- get special path end ----------------- */

dirnam=strdup(sendnam);
pt=strchr(dirnam,'\\'); pName=NULL;
do{
	if(pt==dirnam){ Info=0; adr=pblk->HDadr; pName=pt+1; }
	else { adr=cDir->subTadr; pName = pName==NULL? dirnam:pt+1; }
	if(n>-1){ cDir->subTadr=n; n=-1; }/* recover */
	pt=strchr(pName,'\\');
	if(pt!=NULL)*pt=0;
	Dir=BrowsDir(pblk,pName,adr);	Info++;
	if(Dir==NULL){
	  free(dirnam);
	  if(pt!=NULL){/* !=NULL */
		err2: *Msg=0;
		err1: if(cDir&&cDir!=pblk->cDir)free(cDir);
		err:  popMsg(BinDat[errnmb],sendnam,MB_ICONERROR|STYLE);
		return NULL;
		}
	  else {
		if(flg==1)return cDir!=pblk->cDir||Info>1? cDir:NULL;/* new Dir's parent */
		else goto err1;
		}
	  }
	if(cDir&&cDir!=pblk->cDir)free(cDir);/* free Dir */
	cDir=Dir;	*Msg=adr;
	if(pt==NULL){
	     free(dirnam);
	     if(flg==1){ errnmb=10; goto err2; } 
	     return Dir;
	     }
}while(pt);

}

XBinDir *DirOpen(XBIN *pblk,char *dirnam)
{
int pDir=0;
XBinDir *Dir=SeekDir(pblk,dirnam,&pDir);
if(Dir&&Dir!=pblk->cDir)DirStatInit(Dir);
return Dir;
}
