/*
  Designed by LinJiangHua(xempo) 2002-2004, develop...
  Copyright 2004-2005 Linjianghua(xempo).

  The file is free Sofeware, but no belong to GNU,
  you can redistribute it and/or modify it as published by the Free Software.
*/

#include <stdio.h>
#include <fcntl.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/stat.h>
#include "extext.hpp"


#ifndef P_POPMSG
#define P_POPMSG
int (*popMsg)(char *txt,char *cap,int msg);
#endif

void (*BrowFK)(char *txt,char *cap);
/* cbase *base; */

void FDprj::txtfree()
{
long i;
if(fileRec)free(fileRec);
if(invfile)free(invfile);
if(ReVar)free(ReVar);
if(org)free(org);/*	free(nw);	} */
if(dOrg)free(dOrg);
for(i=0;i<nSort;i++)if(stmde[i]){
	free(cmpbk[i]);stmde[i]=0;
	}
if(mmdat){
	for(i=0;i<ndt;i++)free(mmdat[i]);
	free(mmdat);
}
memset(this,0,sizeof(FileData));
}

/*-------------setfiledata implement------------------------------------*/
void FDprj::DatCount(DatCtrl *ctrl,long addcn)/* realloc org,nw */
{
if(ctrl->tn>=ctrl->mmn){
	char **tmpo,**tmpn;
	long t;
	ctrl->mmn += addcn;
	tmpo=(char **)malloc(ctrl->mmn*8);
	tmpn=tmpo+ctrl->mmn;
	if(ctrl->tn>0){
	    for(t=0;t<ctrl->tn;t++)
		{ tmpo[t]=ctrl->dat1[t]; tmpn[t]=ctrl->dat2[t];	}
	    free(ctrl->dat1);
		}
	ctrl->dat1=tmpo;	ctrl->dat2=tmpn;
	}
}

void FDprj::AddMsg(char **dat,char *add_)
{
UINT vln,dln;
char *vp;
vln= *dat? strlen(*dat):0;
dln=vln+strlen(add_)+8; /* in fact, alloc mem at least:len+1 every time. */
vp=(char *)malloc(dln);
if(*dat){	strcpy(vp,*dat);
		vp[vln++]='\r';	vp[vln]='\n';
		strcpy(vp+vln+1,add_);
		free(*dat);
		}
else strcpy(vp,add_);
*dat=vp;
}

bool FDprj::FitData(char *pt,char chr)
{
bool bk=nofg;
char *ip;
if(chr==13||pt[0]==0||bk)nofg=FALSE;/*  it must do in here */
// fg=3;
ip=memstr(pt,0,"rem",3, 3);
if(ip&& (ip==pt||*(ip-1)==32||*(ip-1)=='=') && (ip[3]==32||ip[3]==0))
{
	*ip=0;
	if(chr!=13)nofg=TRUE;
	if(ip==pt)return FALSE;
}

// fg=1+2;
ip=memstr(pt,0,"//",2, 2);
if(ip){
	*ip=0;
	if(chr!=13)nofg=TRUE;
	if(ip==pt)return FALSE;
}

return TRUE;
}

int FDprj::ValMode(char *hddat,char chr)
{/* [ Mode set = 1 ]   0 is normal, otherwise is reset */
char *bak,*hd,*pt;
int len;
bool fg=FALSE;
if(!FitData(hddat,chr))return TRUE;  /* is the mode,so skip */

len=fmtVal(hddat);
if(*hddat==0)return TRUE;  /* is the mode */
if( hddat[0]!='[' || hddat[len-1]!=']' )return FALSE; /* is not mode */

/* ValSet=0; have done */
bak=(char *)malloc(len+4);
hddat[len-1]=0;
strcpy(bak,hddat+1);
pt=strchr(bak,'=');
if(pt){		*pt=0;
	fmtVal(bak);
	if(stricmp(bak,"Mode set")==0){
		fmtVal(++pt);
		ValSet=atoi(pt);
		fg=TRUE;
	}
}
free(bak);
return fg;
}

long FDprj::VerifyDat(char *pt,char CH,long msg)
/* i>=0 the dat is effect,ǿȡ(еλ);0 no effect  */
{
char *ip,*np;
// bool flg;
long t,cur,i,tn=TN;
DatCount((DatCtrl *)&TN,32);
if( CH>125 )goto skp;
if( ValMode(pt,CH) )return -1;

ip=strchr(pt,'=');/*ѰFitData뿪˺Ĺ02-9-6*/
if(ip==NULL)return -1;
*ip=0;	ip++;

org[tn]=pt;	oln=fmtVal(pt);
nw[tn]=ip;	nwln=fmtVal(ip);
if(oln==0||nwln==0)return -1;

if(ValSet){
	np=org[tn];
	org[tn]=nw[tn];
	nw[tn]=np;
}
skp:	cur=tn;

for(t=0;t<tn;t++){/* ǷѼص*/
// flg=1+(msg&2);
 if(memstr(org[cur],0,org[t],0, 1+(msg&2) )){
   if(CmpMsg){
	if(stricmp(nw[t],nw[cur])==0)return -1; /*  2 both equ */
	if((msg&2)==0){ /* can't set mult-val ظֵ */

		AddMsg(&ReVar,org[cur]);
		cnReV++;	err=TRUE;
		return -1;
			}
	else break;
	  }
  else {/* only compare first ʵֻȽһΣһʵ */
	ip=org[cur];	np=nw[cur];
		for(i=tn;i>t;i--){
			org[i]=org[i-1];
			nw[i]=nw[i-1];
			}
		org[t]=ip;		nw[t]=np;
		cur=t;/* adjust Ƚʱֵ(pos) */
		break; /* is right ?? */
	 }
  }
}/* is loaded? */
TN++;
return cur;
}

char **FDprj::ReAppDat(char **dat,long *m,long n)
{/* *m is dat's count  */
if(*m<=n){
char **tmp;
int a,cn;
*m += 8; cn=*m;
tmp=(char **)malloc( cn * 4 );
for(a=0; a < cn ; a++)tmp[a]=a<n? dat[a]:NULL;
if( n > 0 )free(*dat);
return tmp;
	}
else return dat;
}

char **FDprj::CountFile(char *inpt)
{
char *pt,**fname,*hd;
// bool fg,fg2;
long t, 	fn=8;
fname=(char **)malloc(fn*4);
hd=inpt;	pt=inpt;
cnfile=0;		/* init dats */
memset(fname,0,32);
	while(*pt){
	if(*pt==','||pt[1]==0&&fname[cnfile]!=pt){
		if(*pt==',')*pt=0;
		fname[cnfile]=hd; hd=pt+1;
	for(t=0;t<cnfile;t++)if(stricmp(fname[t],fname[cnfile])==0)goto skp;
	// fg=3;fg2=3;
	if(memstr(fileRec,0,fname[cnfile],0, 3)
	||memstr(invfile,0,fname[cnfile],0, 2))goto skp;
	fname=ReAppDat(fname,&fn,++cnfile);
	}
skp:pt++;
}
return fname;
}


void FDprj::ReCmpbk()
/* ·ڴcmpbk;undo,¼(Load agein)֮ǰ */
{
long i, k, *tmp,  cn, m=TN; /* !!?? */
cn=m;/* adds; */
for(k=0;k<nSort;k++)if(stmde[k]>0){
		tmp=(long  *)malloc(cn*4);
		for(i=-0;i<m;i++)tmp[i]=cmpbk[k][i];
		free(cmpbk[k]);
		cmpbk[k]=tmp;
	}
}

long FDprj::txtpro(char *buf, long len,long msg)/* return loaded data's count */
{
long t, n, i, rt, datlen;
char chr, *pt;
if(len ==0)len=strlen(buf);
nofg = FALSE;	ValSet = 0;
n = TN;   pt = buf;
/* above is init some members var of class */
for (i = 0, datlen = 0; i < len; i++){
  chr = buf[i];
  if (chr == 10 || chr == 13 || chr == ';') {
	 buf[i] = 0;
/*   if(chr==13)nofg=FALSE;//һҪreturn ǰΪnofg¸ֵ */
	 if (VerifyDat(pt, chr,msg)>-1)datlen += oln + nwln + 2;
		 /* olnVerifyDayеfmtValȡorg[TN-1]ĳ,nwlnͬ... */
	 if (buf[i + 1] == 10){	pt = buf + i + 2;	i++; }
	 else	pt = buf + i + 1;
	  }
   }
if(pt < buf + i)if(VerifyDat(pt, chr,msg)>-1) datlen += oln + nwln + 2;

rt=TN-n;
if(rt==0)free(buf);
else {
mmdat=ReAppDat(mmdat, &mdt, ndt);
/*====ѹ compacted ==========*/
if (datlen+512 < len) {
pt = (char *) malloc(datlen + 4);
mmdat[ndt] = pt;
for (t = n; t < TN; t++){
 strcpy(pt, org[t]);
 org[t] = pt;
 pt += strlen(org[t]) + 1;
 strcpy(pt, nw[t]);
 nw[t] = pt;
 pt += strlen(nw[t]) + 1;
	  }
  free(buf);
   }
/*====compacted ==========*/
else mmdat[ndt] = buf;
ndt++;
}
/*ReCmpbk(rt);*/
return rt;
}

/*-------------------------load file data ---------------------------------------
load file msg
0 pop msg for show no effect loaded data.
1 the source var can set mult-value. //ʾ''ظֵ;
2 if 1 bit set 0, show the mult-var,//1λʱ'ʾ'ظ;
long msg; above is bit pos  //default is 1+0+4
*/
void FDprj::LoadFile(char *fnames,long msg)
{
unsigned int len;
char **flnm,*buf;
long j, cnOrg;
// int fhl;
if(fnames==NULL||fnames[0]==0){
	popMsg(dscpt[0],0,MB_ICONERROR);
	return;
}
err=FALSE;

flnm=CountFile(fnames);
if( (msg&1) && cnfile==0){
	popMsg(dscpt[1],0,MB_ICONWARNING);
	free(flnm); return;
}
cnOrg=cnRec;

/*-------------processe file----------------*/

for(j=0;j<cnfile;j++){
 if( (buf=ReadFile(flnm[j],&len)) ){
  if(txtpro(buf,len,msg)>0){  /* return add cn */
	AddMsg(&fileRec,flnm[j]);
	cnRec++;
	}
  else AddMsg(&invfile,flnm[j]); /* set dat=0 */
 }
}
/* ----processe file end----------- */
if(cnRec==cnOrg){/* msg:some use no need this warn */
	if(msg&1)popMsg(dscpt[4],0,MB_ICONERROR);
	}
else chgSort=1;

free(flnm);

if(err && (msg&4)==0 && (msg&8) && ReVar)BrowFK(ReVar,dscpt[5]);
}
/*---------------------load file data end ------------------------------------------*/

/* sort mode: msgST
0bit=0 no sort;
1bit=0 sort org;		=1 sort  nw
3bit=0(A=1);3bit=1(A=-1)ǽ----------fdSort
fnm is null, only sort
*/
long FDprj::DataOut(char *fnm,short msgST,long add)
{
long a, j, f, sfg, A, rt, addr; /*cmpbk index //(߼ַ); */
short usepos, n;
FILE *hl;
UINT len1,len2,tln;
char *indat,*op,**dstfd;
if(msgST>=0)fdSort=msgST;

if(TN<=0){
	if(fnm)popMsg(dscpt[6],0,MB_ICONWARNING);
	return -1;
}

if(fnm){
	hl=fopen(fnm,"wb+");
	if(hl==NULL){ KShowMsg(fnm,dscpt[7],0); return -1;	}
	}

sfg=msgST&1;
A=msgST&8 ? -1:1;
dstfd = msgST&2? nw : org; /* (1 bit)=0 org sort */
tln=0;	indat=NULL;

if(sfg){
	if(chgSort){
		for(j=0;j<nSort;j++)if(stmde[j])/* update */
			{free(cmpbk[j]);	stmde[j]=0;	}/* wait... */
	}
for(usepos=0;  usepos<nSort && stmde[usepos]!=0; usepos++);
for(n=0;n<nSort&&(stmde[n]&2)!=(fdSort&2);n++);
if(n<nSort&&stmde[n]>0)usepos=n;
else {
	cmpbk[usepos]=(long *)malloc(4*TN);
	stmde[usepos]=fdSort;
	for(a=0;a<TN;a++)cmpbk[usepos][a]=a;
	n=100;/* flg for nw[] */
	}
	IdxMde=usepos;
}
else IdxMde=0;

for(a=0;a<TN;a++){
/*============= sort ==============================*/
if(sfg){
	if(n>=nSort){
/* ++++++++++++++++++++++++++++ */
	f=cmpbk[usepos][a]; op=dstfd[f];	addr=a;
	for(j=a+1;j<TN;j++){
		if(A*stricmp(op,dstfd[cmpbk[usepos][j]])>0){
		f=cmpbk[usepos][j];op=dstfd[f];addr=j;
		}
	}
cmpbk[usepos][addr]=cmpbk[usepos][a]; /* ԭֵ[a]İ */
cmpbk[usepos][a]=f;
if(f==add)rt=a;
	}
/* +++++++++++++++++++++++++++ */
	else {
		if(stmde[usepos]==fdSort)f=cmpbk[usepos][a];
		else f=cmpbk[usepos][TN-a-1];
	}
}
else f=a;/*no sort*/
/*   f(ԭֻfilef)   */
if(fnm){
	len1=strlen(org[f]);	len2=strlen(nw[f]);
	if(tln<len1+len2+5){
		if(indat)free(indat);
		indat=(char *)malloc(len1+len2+5);
	}
	tln=len1+len2+5;
	strcpy(indat,org[f]);	indat[len1]='=';
	strcpy(indat+len1+1,nw[f]);
	indat[tln-4]=13;indat[tln-3]=10;
	fwrite(indat,tln-2,1,hl);
}

}
if(fnm){ /* chsize(hl, tell(hl)); */ fclose(hl); }
chgSort=0;
return rt;
}

void FDprj::DataInfo()
{
long ln1,ln2,len;
char *pt;
ln1=invfile? strlen(invfile):0;
ln2=ReVar? strlen(ReVar):0;
len=fileRec? strlen(fileRec):0;
pt=(char *)malloc(ln1+ln2+len+100);
sprintf(pt,"Ѽ˵ļ%d",cnRec);
len=strlen(pt);
pt[len++]=13; pt[len++]=10;
sprintf(pt+len, "%s\r\nĿ%d", (fileRec==NULL?  "δЧ" : fileRec),TN );

if(invfile)sprintf(pt+strlen(pt),"\r\n\r\nЧļѼ:\r\n%s",invfile);
	
if(ReVar)sprintf(pt+strlen(pt),"\r\n\r\nظֵı:%d\r\n%s",cnReV,ReVar);

BrowFK(pt,"ظſ");
}

void FDprj::_Deldata(int n)
{
int i;
DatCount((DatCtrl *)&dTN,10);
dOrg[dTN]=org[n];
dNw[dTN++]=nw[n];
TN--;
for(i=n;i<TN;i++){
	org[i]=org[i+1];
	nw[i]=nw[i+1];
	}
}

long FDprj::Deldata(long n) /* return -1 is false, otherwise ... */
{
if(n<TN){
long pos, k, i, dtpos, cn;
if((fdSort & 1)==0){_Deldata(n);return n;} /* no sort */
else {
	pos=fdSort & 8 ? TN-1 - n : n;
	dtpos=cmpbk[IdxMde][pos];
	_Deldata(dtpos);

	cn=TN;/* fast */
	for(k=0;k<nSort;k++)if(stmde[k]>0){
		/* 2 scan loop */
		for(i=pos;i<cn;i++)cmpbk[k][i]=cmpbk[k][i+1];
		for(i=0;i<cn; i++)if(cmpbk[k][i]>dtpos)cmpbk[k][i]--;
		/* 2 scan loop */
	}
	return dtpos;
	}
}
else return -1;
}

/*void SortAdd(int add)
{
int A, i, cn, n=IdxMde;
char *Apt, **pt=fdSort&2? org:nw;
Apt=org[add];
A=fdSort & 8? 1:-1;
cn=TN;
for(i=0;i<TN;i++){
	if(A*NmCmp(Apt,pt[cmpbk[n][i])>0)
	}
}*/

long FDprj::undel( )
{
if(dTN>0){
	chgSort=1;
	dTN--;
	org[TN]=dOrg[dTN];
	nw[TN]=dNw[dTN];
	return VerifyDat(NULL,127,5);
	}
	return -1;
}

/*bool expfun DllLnk(Txtfun *pt)
{
=(FileData *)malloc(sizeof(FileData));
memset(,0,sizeof(FileData));
pt->DataInfo=DataInfo;
pt->txtpro=txtpro;
pt->LoadFile=LoadFile;
pt->Deldata=Deldata;
pt->dataOut=dataOut;
pt->txtfree=txtfree;
pt->undel=undel;
//----------base----------------
if(pt->base==NULL){
void (*dllLnk)(cbase *);
FARPROC pfun;
basehdl=LoadLibrary("NormLib.dll");
if(basehdl){
pfun=GetProcAddress(basehdl,"DllLnk");
if(pfun==NULL)return FALSE;
base=(cbase *)malloc(sizeof(cbase));
pt->base=base;
dllLnk=(void (__cdecl *)(cbase *))pfun;
dllLnk(base);
	}
else return FALSE;
}
else base=pt->base;
//----------base-----------------

//-----import------------
BrowFK=pt->Editbox;
popMsg=pt->popMsg;
return TRUE;
}

*/

